/******************************************************************************

  interrupts.c 

  list of interrutps that is called by the interrupt vector and are in use 
  in our system. 
  timers, exteranl interruts, exceptions, etc.

******************************************************************************/


#include "nordic_common.h"
#include "nrf.h"
#include "nrf_log.h"
#include "nrf_log_ctrl.h"
#include "nrf_log_default_backends.h"
#include "nrf_drv_swi.h"
#include "interrupts.h"

static nrf_swi_t int_high_pr_swi;


/******************************************************************************

  int_high_pr_handler

******************************************************************************/
static void int_high_pr_handler(nrf_swi_t swi, nrf_swi_flags_t mask)
{
    if ( swi == int_high_pr_swi )
    {
      /* If "int_high_pr_swi" was triggered and flag #3 is present... */
      if ( mask & (1<<INT_1SEC) )
      {
        void timer_1sec_handler_swi(void);
        timer_1sec_handler_swi();
      }
    }
}

/******************************************************************************

  int_init

******************************************************************************/
void int_init(void)
{
  /* Initialize the library. */
  ret_code_t err_code = nrf_drv_swi_init();
  APP_ERROR_CHECK(err_code);
  
  /* Allocate and setup one SWI. */
  err_code = nrf_drv_swi_alloc(&int_high_pr_swi, int_high_pr_handler, APP_IRQ_PRIORITY_MID);
  APP_ERROR_CHECK(err_code);
}

/******************************************************************************

  int_high_pr_generate

******************************************************************************/
void int_high_pr_generate(uint8_t bit)
{
  /* Trigger SWI */
  nrf_drv_swi_trigger(int_high_pr_swi, bit);
}
